Skip to main content

Genie

View as Markdown

Genie Cancel Response GA

POST /api/2.0/genie/agents/{agent_id}/conversations/{conversation_id}/responses/{response_id}/cancel

Cancels an in-flight agent-mode response. response_id is the id returned in the response.created event from the agent-mode responses endpoint. The response stops at the next agent boundary and its terminal state is returned.

API scopes: genie

Parameters

agent_idstringRequiredpath

The ID of the Genie agent (synonymous with the Genie space ID).

Example: e1ef34712a29169db030324fd0e1df5f

conversation_idstringRequiredpath

The ID of the conversation containing the response.

Example: e1ef34712a29169db030324fd0e1df5f

response_idstringRequiredpath

The ID of the response to cancel (the id from the response.created event).

Example: e1ef34712a29169db030324fd0e1df5f

Response

idstring

Message ID. Legacy identifier, use message_id instead

Example: e1ef34712a29169db030324fd0e1df5f

space_idstringRequired

Genie space ID

Example: e1ef34712a29169db030324fd0e1df5f

conversation_idstringRequired

Conversation ID

Example: e1ef34712a29169db030324fd0e1df5f

user_idint64

ID of the user who created the message

created_timestampint64

Timestamp when the message was created

last_updated_timestampint64

Timestamp when the message was last updated

statusstring

MessageStatus. The possible values are:

  • FETCHING_METADATA: Fetching metadata from the data sources.
  • FILTERING_CONTEXT: Running smart context step to determine relevant context.
  • ASKING_AI: Waiting for the LLM to respond to the user's question.
  • PENDING_WAREHOUSE: Waiting for warehouse before the SQL query can start executing.
  • EXECUTING_QUERY: Executing a generated SQL query. Get the SQL query result by calling getMessageAttachmentQueryResult API.
  • FAILED: The response generation or query execution failed. See error field.
  • COMPLETED: Message processing is completed. Results are in the attachments field. Get the SQL query result by calling getMessageAttachmentQueryResult API.
  • SUBMITTED: Message has been submitted.
  • QUERY_RESULT_EXPIRED: SQL result is not available anymore. The user needs to rerun the query. Rerun the SQL query result by calling executeMessageAttachmentQuery API.
  • CANCELLED: Message has been cancelled.

Values: FETCHING_METADATA, FILTERING_CONTEXT, ASKING_AI, PENDING_WAREHOUSE, EXECUTING_QUERY, FAILED, COMPLETED, SUBMITTED, QUERY_RESULT_EXPIRED, CANCELLED

Example: ASKING_AI

contentstringRequired

User message content

Example: Biggest open opportunities

attachmentsarray of object

AI-generated response to the message

Show child attributesHide child attributes
textobject

Text Attachment if Genie responds with text This also contains the final summary when available.

Show child attributesHide child attributes
contentstring

AI generated message

idstring
purposestring

Purpose of this text attachment. A completed message may contain more than one text attachment (for example a clarifying follow-up question alongside the final answer); use this field to tell them apart. TEXT_ATTACHMENT_PURPOSE_ANSWER marks the final answer/summary and FOLLOW_UP_QUESTION marks a clarifying question.

Values: TEXT_ATTACHMENT_PURPOSE_UNSPECIFIED, FOLLOW_UP_QUESTION, TEXT_ATTACHMENT_PURPOSE_ANSWER

queryobject

Query Attachment if Genie responds with a SQL query

Show child attributesHide child attributes
titlestring

Name of the query

querystring

AI generated SQL query

descriptionstring

Description of the query

last_updated_timestampint64

Time when the user updated the query last

parametersarray of object
Show child attributesHide child attributes
keywordstring
valuestring
sql_typestring
idstring
statement_idstring

Statement Execution API statement id. Use Get status, manifest, and result first chunk to get the full result data.

query_result_metadataobject

Metadata associated with the query result.

Show child attributesHide child attributes
row_countint64

The number of rows in the result set.

is_truncatedboolean

Indicates whether the result set is truncated.

thoughtsarray of objectPublic Preview

Insights into how Genie came to generate the SQL.

Show child attributesHide child attributes
thought_typestringPublic Preview

The category of this thought. The possible values are:

  • THOUGHT_TYPE_DESCRIPTION: A high-level description of how the question was interpreted.
  • THOUGHT_TYPE_UNDERSTANDING: How ambiguous parts of the question were resolved.
  • THOUGHT_TYPE_DATA_SOURCING: Which tables or datasets were identified as relevant.
  • THOUGHT_TYPE_INSTRUCTIONS: Which author-defined instructions were referenced.
  • THOUGHT_TYPE_STEPS: The logical steps taken to compute the answer.

Values: THOUGHT_TYPE_UNSPECIFIED, THOUGHT_TYPE_DESCRIPTION, THOUGHT_TYPE_UNDERSTANDING, THOUGHT_TYPE_DATA_SOURCING, THOUGHT_TYPE_INSTRUCTIONS, THOUGHT_TYPE_STEPS

contentstringPublic Preview

The md formatted content for this thought.

suggested_questionsobject

Follow-up questions suggested by Genie

Show child attributesHide child attributes
questionsarray of string

The suggested follow-up questions

vizobjectBeta

Visualization generated by Genie, if requested via enable_visualization

Show child attributesHide child attributes
titlestringBeta

Name of the visualization

query_attachment_idstringBeta

The ID of the query attachment the visualization was generated from

attachment_idstring

Attachment ID

query_resultobject

The result of SQL query if the message includes a query attachment. Deprecated. Use query_result_metadata in GenieQueryAttachment instead.

Show child attributesHide child attributes
statement_idstring

Statement Execution API statement id. Use Get status, manifest, and result first chunk to get the full result data.

row_countint64

Row count of the result

is_truncatedboolean

If result is truncated

statement_id_signaturestring

JWT corresponding to the statement contained in this result

errorobject

Error message if Genie failed to respond to the message

Show child attributesHide child attributes
errorstring
typestring

Values: TYPE_UNSPECIFIED, UNEXPECTED_REPLY_PROCESS_EXCEPTION, GENERIC_CHAT_COMPLETION_EXCEPTION, CONTEXT_EXCEEDED_EXCEPTION, DEPLOYMENT_NOT_FOUND_EXCEPTION, FUNCTIONS_NOT_AVAILABLE_EXCEPTION, INVALID_COMPLETION_REQUEST_EXCEPTION, CONTENT_FILTER_EXCEPTION, FUNCTION_ARGUMENTS_INVALID_JSON_EXCEPTION, RETRYABLE_PROCESSING_EXCEPTION, INVALID_FUNCTION_CALL_EXCEPTION, LOCAL_CONTEXT_EXCEEDED_EXCEPTION, CHAT_COMPLETION_NETWORK_EXCEPTION, INVALID_CHAT_COMPLETION_JSON_EXCEPTION, GENERIC_CHAT_COMPLETION_SERVICE_EXCEPTION, WAREHOUSE_ACCESS_MISSING_EXCEPTION, WAREHOUSE_NOT_FOUND_EXCEPTION, NO_TABLES_TO_QUERY_EXCEPTION, SQL_EXECUTION_EXCEPTION, REPLY_PROCESS_TIMEOUT_EXCEPTION, COULD_NOT_GET_UC_SCHEMA_EXCEPTION, INVALID_TABLE_IDENTIFIER_EXCEPTION, TOO_MANY_TABLES_EXCEPTION, FUNCTION_ARGUMENTS_INVALID_EXCEPTION, GENERIC_SQL_EXEC_API_CALL_EXCEPTION, CHAT_COMPLETION_CLIENT_EXCEPTION, CHAT_COMPLETION_CLIENT_TIMEOUT_EXCEPTION, UNKNOWN_AI_MODEL, TABLES_MISSING_EXCEPTION, MESSAGE_DELETED_WHILE_EXECUTING_EXCEPTION, MESSAGE_UPDATED_WHILE_EXECUTING_EXCEPTION, BLOCK_MULTIPLE_EXECUTIONS_EXCEPTION, INVALID_CERTIFIED_ANSWER_IDENTIFIER_EXCEPTION, TOO_MANY_CERTIFIED_ANSWERS_EXCEPTION, RATE_LIMIT_EXCEEDED_GENERIC_EXCEPTION, RATE_LIMIT_EXCEEDED_SPECIFIED_WAIT_EXCEPTION, FUNCTION_CALL_MISSING_PARAMETER_EXCEPTION, INVALID_CERTIFIED_ANSWER_FUNCTION_EXCEPTION, ILLEGAL_PARAMETER_DEFINITION_EXCEPTION, NO_QUERY_TO_VISUALIZE_EXCEPTION, NO_DEPLOYMENTS_AVAILABLE_TO_WORKSPACE, STOP_PROCESS_DUE_TO_AUTO_REGENERATE, FUNCTION_ARGUMENTS_INVALID_TYPE_EXCEPTION, MESSAGE_CANCELLED_WHILE_EXECUTING_EXCEPTION, COULD_NOT_GET_MODEL_DEPLOYMENTS_EXCEPTION, GENERATED_SQL_QUERY_TOO_LONG_EXCEPTION, MISSING_SQL_QUERY_EXCEPTION, DESCRIBE_QUERY_UNEXPECTED_FAILURE, DESCRIBE_QUERY_TIMEOUT, DESCRIBE_QUERY_INVALID_SQL_ERROR, INVALID_SQL_UNKNOWN_TABLE_EXCEPTION, INVALID_SQL_MULTIPLE_STATEMENTS_EXCEPTION, INVALID_SQL_MULTIPLE_DATASET_REFERENCES_EXCEPTION, MESSAGE_ATTACHMENT_TOO_LONG_ERROR, INTERNAL_CATALOG_PATH_OVERLAP_EXCEPTION, INTERNAL_CATALOG_MISSING_UC_PATH_EXCEPTION, EXCEEDED_MAX_TOKEN_LENGTH_EXCEPTION, INTERNAL_CATALOG_ASSET_CREATION_ONGOING_EXCEPTION, INTERNAL_CATALOG_ASSET_CREATION_FAILED_EXCEPTION, INTERNAL_CATALOG_ASSET_CREATION_UNSUPPORTED_EXCEPTION, UNSUPPORTED_CONVERSATION_TYPE_EXCEPTION, COULD_NOT_GET_DASHBOARD_SCHEMA_EXCEPTION

message_idstringRequired

Message ID

Example: e1ef34712a29169db030324fd0e1df5f

feedbackobject

User feedback for the message if provided

Show child attributesHide child attributes
ratingstring

The feedback rating

Values: GENIE_FEEDBACK_RATING_UNSPECIFIED, POSITIVE, NEGATIVE, NONE

commentstringPublic Preview

Optional feedback comment text